// #name = Pizza Client ETM
// #version = 1.1
// #author = altair
// #email = altair@ngi.it

if(!isObject(ETMmode))
{
	new ScriptObject(ETMmode)
	{
		class = ETMmode;
	};
}

if(!isFile("prefs/eTourneyClan.cs"))
{
	%write = new fileObject();
	%write.openForWrite("prefs/eTourneyClan.cs");
	%write.writeLine("$eTCounter = -1;");
	%write.writeLine("$eTClan[$eTCounter++] = \"Choose clan\";");
	%write.close();
	%write.delete();
}

function MapNumber::FillList(%this)
{
	%this.add("Choose Map Number", 0);
	%this.add("First Map", 1);
   %this.add("Second Map", 2);
   %this.add("Third Map", 3);
}

function ETMmode::FillClanList(%this)
{
	StormClan.clear();
	InfernoClan.clear();
	
	for(%x = 0; %x <= $eTCounter; %x++)
	{
		if($eTClan[%x] !$= "")
		{
			StormClan.add($eTClan[%x], %x);
			InfernoClan.add($eTClan[%x], %x);
		}
	}
}

function MapNumber::choosed(%this)
{
	if(%this.getSelected() == 0)
	{
		ETMmode.resetList();
	   $ClientETMCurrentMap = 0;
		return;
	}
	
	$ClientETMCurrentMap = %this.getSelected();
	
	ETMmode.resetList();
   ETMmode.FillMissionTypeMenu();
   
   MapChoosed.setValue($ClientETMDisplayName[$ClientETMCurrentMap]);
   StormClanChoosed.setValue($ClientETMStormClan[$ClientETMCurrentMap]);
   InfernoClanChoosed.setValue($ClientETMInfernoClan[$ClientETMCurrentMap]);
}

function StormClan::choosed(%this)
{
	if(%this.getSelected() == 0 || $ClientETMCurrentMap == 0)
		return;
	
	$ClientETMStormClan[$ClientETMCurrentMap] = %this.getText();
	
	StormClanChoosed.setValue($ClientETMStormClan[$ClientETMCurrentMap]);
}

function InfernoClan::choosed(%this)
{
	if(%this.getSelected() == 0 || $ClientETMCurrentMap == 0)
		return;
	
	$ClientETMInfernoClan[$ClientETMCurrentMap] = %this.getText();
	
	InfernoClanChoosed.setValue($ClientETMInfernoClan[$ClientETMCurrentMap]);
}

function ETMmode::AddClan(%this)
{
	if(InsNewClan.getValue() $= "")
		return;

	%read = new fileObject();
	%read.openForRead("../base/prefs/eTourneyClan.cs");
	while(!%read.isEOF())
		%read.readLine();
	%read.close();
	%read.delete();
	
	%write = new fileObject();
	%write.openForAppend("../base/prefs/eTourneyClan.cs");
	%write.writeLine("$eTClan[$eTCounter++] = \"" @ InsNewClan.getValue() @ "\";");
	%write.close();
	%write.delete();
	
	InsNewClan.setValue("");
	exec("prefs/eTourneyClan.cs");
	ETMmode.FillClanList();
	StormClan.setSelected(0);
	InfernoClan.setSelected(0);
}

function ETMmode::RemoveClan(%this)
{
	if(InfernoClan.getSelected() == 0)
		return;
		
	%clanRowCount = 0;
	
	%read = new fileObject();
	%read.openForRead("../base/prefs/eTourneyClan.cs");
	while(!%read.isEOF())
	{
		%clanRow[%clanRowCount++] = %read.readLine();
		
		if(strStr(%clanRow[%clanRowCount], InfernoClan.getText()) != -1)
			%lineRow = %clanRowCount;
	}
	%read.close();
	%read.delete();
	
	%write = new fileObject();
	%write.openForWrite("../base/prefs/eTourneyClan.cs");
	for(%x = 1; %x <= %clanRowCount; %x++)
	{
		if(%x != %lineRow)
			%write.writeLine(%clanRow[%x]);
	}
	%write.close();
	%write.delete();
	
	deleteVariables("$eTC*");
	exec("prefs/eTourneyClan.cs");
	ETMmode.FillClanList();
	StormClan.setSelected(0);
	InfernoClan.setSelected(0);
}

function ETMmode::FillMissionTypeMenu(%this)
{
   MapVoteMenu.key++;
   MapVoteMenu.clear();
   MapVoteMenu.mode = "type";
   commandToServer('GetETMMissionTypes', MapVoteMenu.key);
}

function ETMmode::FillMissionMenu(%this, %type, %typeName)
{
   MapVoteMenu.key++;
   MapVoteMenu.clear();
   MapVoteMenu.mode = "mission";
   MapVoteMenu.missionType = %type;
   MapVoteMenu.typeName = %typeName;
   commandToServer('GetETMMissionList', MapVoteMenu.key, %type);
   MapCancelBtn.setVisible(true);
}

function ETMmode::reset(%this)
{
   MapVoteMenu.clear();
	MapVoteMenu.mode = "";
   MapVoteMenu.tourneyChoose = 0;
   MapCancelBtn.setVisible(false);
   ETMmode.FillMissionTypeMenu();
}

function ETMmode::resetList(%this)
{
   MapVoteMenu.clear();
	MapVoteMenu.mode = "";
   MapVoteMenu.tourneyChoose = 0;
   MapCancelBtn.setVisible(false);
   StormClan.setSelected(0);
   StormClanChoosed.setValue("");
	InfernoClan.setSelected(0);
	InfernoClanChoosed.setValue("");
	MapChoosed.setValue("");
}

function ETMmode::resetAll(%this)
{
	MapNumber.setSelected(0);
	ETMmode.resetList();
	deleteVariables("$ClientETM*");
	commandToServer('ETMResetAllMaps');
}

addMessageCallback('MsgETMVoteItem', handleETMVoteItemMessage);

function handleETMVoteItemMessage(%msgType, %msgString, %key, %voteName, %voteActionMsg, %voteText, %sort)
{
   if(%key != MapVoteMenu.key)
      return;

   %index = MapVoteMenu.rowCount();
   
   MapVoteMenu.addRow(%index, detag(%voteText));
   
   if(%sort)
      MapVoteMenu.sort(0);
      
   $clVoteCmd[%index] = detag(%voteName);
}

function ETMmode::vote(%this)
{
   %id = MapVoteMenu.getSelectedId();
   %text = MapVoteMenu.getRowTextById(%id);
   
   switch$(MapVoteMenu.mode)
   {
      case "type":
         ETMmode.FillMissionMenu($clVoteCmd[%id], %text);
         return;

      case "mission":
      	$ClientETMDisplayName[$ClientETMCurrentMap] = %text;						// Mission display name
      	$ClientETMTypeName[$ClientETMCurrentMap] = MapVoteMenu.typeName;		// Mission type display name
      	$ClientETMMissionId[$ClientETMCurrentMap] =$clVoteCmd[%id];				// Mission id
      	$ClientETMTypeId[$ClientETMCurrentMap] = MapVoteMenu.missionType;		// Mission type id
      	
      	MapChoosed.setValue($ClientETMDisplayName[$ClientETMCurrentMap]);
      	
         ETMmode.reset();
         return;
   }
}

function ETMmode::confirm(%this)
{
	if($ClientETMDisplayName[$ClientETMCurrentMap] $= "" || $ClientETMTypeName[$ClientETMCurrentMap] $= "" || $ClientETMMissionId[$ClientETMCurrentMap] $= "" || $ClientETMTypeId[$ClientETMCurrentMap] $= "" || $ClientETMStormClan[$ClientETMCurrentMap] $= "" || $ClientETMInfernoClan[$ClientETMCurrentMap] $= "")
	{
		addMessageHudLine("\c2Please fill all the options.");
		return;
	}
	
	commandToServer('ETMReceiveMap', $ClientETMMissionId[$ClientETMCurrentMap], $ClientETMTypeId[$ClientETMCurrentMap], $ClientETMDisplayName[$ClientETMCurrentMap], $ClientETMTypeName[$ClientETMCurrentMap], $ClientETMStormClan[$ClientETMCurrentMap], $ClientETMInfernoClan[$ClientETMCurrentMap], $ClientETMCurrentMap);
	
	switch$($ClientETMCurrentMap)
	{
		case "1":
			ETMmode.NextMap(2);
		case "2":
			ETMmode.NextMap(3);
		case "3":
			ETMmode.NextMap(0);
	}
}

function ETMmode::NextMap(%this, %map)
{
	MapNumber.setSelected(%map);
	$ClientETMCurrentMap = %map;
			
	ETMmode.resetList();
   if(%map !$= 0)
   	ETMmode.FillMissionTypeMenu();
}

function ETMmode::UpdateMap(%this)
{
	commandToServer('ETMUpdate', $ClientETMMissionId[$ClientETMCurrentMap], $ClientETMTypeId[$ClientETMCurrentMap], $ClientETMDisplayName[$ClientETMCurrentMap], $ClientETMTypeName[$ClientETMCurrentMap], $ClientETMStormClan[$ClientETMCurrentMap], $ClientETMInfernoClan[$ClientETMCurrentMap], $ClientETMCurrentMap);
}

addMessageCallback('MsgPizzaUpdated', HidePizzaHud);

function ETMmode::ResetMap(%this)
{
	if($ClientETMCurrentMap != 0)
	{
		ETMmode.resetList();
		ETMmode.FillMissionTypeMenu();
		commandToServer('ETMResetMap', $ClientETMCurrentMap);
	}
}

addMessageCallback('MsgPizzaPassed', startETMvote);

function startETMvote(%msgType, %msgString, %a1, %a2, %a3, %a4)
{
	HidePizzaHud();
	startNewVote("VoteETMmode", %a1, %a2, %a3, %a4);
}