// #name = Pizza Client Options
// #version = 1.1
// #author = altair
// #email = altair@ngi.it

// Create the screenshots dir if not exists
$sspath = new FileObject();
$sspath.openForWrite("PizzaSshots/");
$sspath.close();
$sspath.delete();
$sspath = "";

if(!isFile("prefs/PizzaClientPrefs.cs"))
{
	$PizzaClient::bottomPrint = 1;
	$PizzaClient::SshotDebriefing = 0;
	$PizzaClient::DiscSshot = 0;
	$PizzaClient::DiscSshotdistance = 30;
	$PizzaClient::PlasmaSshot = 0;
	$PizzaClient::PlasmaSshotdistance = 30;
	$PizzaClient::BlasterSshot = 0;
	$PizzaClient::BlasterSshotdistance = 30;
	$PizzaClient::SshotHud = 1;
	$PizzaClient::SnipeSshot = 0;
	$PizzaClient::SnipeSshotHud = 1;
	$PizzaClient::SnipeSshotdistance = 350;
	$PizzaClient::sshotGamma = 0.125;
}
else if(!$PizzaClientPrefsLoaded)
{
	exec("prefs/PizzaClientPrefs.cs");
	$PizzaClientPrefsLoaded = true;
}

// Halide slider code (halsshot)
function updateGammaSshotInterval()
{
	$PizzaClient::sshotGamma = (%gamma = GammaSlider.getValue());
	GammaSliderText.setValue(mFormatFloat(%gamma / 0.5 * 100, "%.f") @ "%");
}

// Uberguy Screenshot code
function takeMAScreenShot(%msgType, %msgString, %distance)
{
	%distance = detag(%distance);
	%msgType = detag(%msgType);

	switch$(%msgType)
	{
		case "MsgMidAir":
			if($PizzaClient::DiscSshot && %distance >= $PizzaClient::DiscSshotdistance)
			{
				for(%found = true; %found; $DiscCount++)
				{
					%suffix = $DiscCount @ ".";
					
					while(strlen(%suffix) < 5)
						%suffix = "0" @ %suffix;
					
					%fileName = "PizzaSshots/Disc" @ %suffix @ "png";
					%found = isFile(%fileName);
				}
				
				%dir = "base/" @ %fileName;
				schedule(100, 0, takeSShot, %dir, 1);
			}

		case "MsgPlasmaMidAir":
			if($PizzaClient::PlasmaSshot && %distance >= $PizzaClient::PlasmaSshotdistance)
			{
				for(%found = true; %found; $PlasmaCount++)
				{
					%suffix = $PlasmaCount @ ".";
					
					while(strlen(%suffix) < 5)
						%suffix = "0" @ %suffix;
					
					%fileName = "PizzaSshots/Plasma" @ %suffix @ "png";
					%found = isFile(%fileName);
				}
				
				%dir = "base/" @ %fileName;
				schedule(100, 0, takeSShot, %dir, 1);
			}

		case "MsgBlasterMidAir":
			if($PizzaClient::BlasterSshot && %distance >= $PizzaClient::BlasterSshotdistance)
			{
				for(%found = true; %found; $BlasterCount++)
				{
					%suffix = $BlasterCount @ ".";
					
					while(strlen(%suffix) < 5)
						%suffix = "0" @ %suffix;
					
					%fileName = "PizzaSshots/Blaster" @ %suffix @ "png";
					%found = isFile(%fileName);
				}
				
				%dir = "base/" @ %fileName;
				schedule(100, 0, takeSShot, %dir, 1);
			}
	}
}

// Uberguy Screenshot code
function takeSnipeScreenShot(%msgType, %msgString, %distance)
{
	%distance = detag(%distance);
	
	if($PizzaClient::SnipeSshot && %distance >= $PizzaClient::SnipeSshotdistance)
	{
		for(%found = true; %found; $SnipeCount++)
		{
			%suffix = $SnipeCount @ ".";
			
			while(strlen(%suffix) < 5)
				%suffix = "0" @ %suffix;
			
			%fileName = "PizzaSshots/Snipe" @ %suffix @ "png";
			%found = isFile(%fileName);
		}
		
		%dir = "base/" @ %fileName;
		schedule(100, 0, takeSShot, %dir, 2);
	}
}

function hideHuds(%val, %type)
{
	if(%type == 1 && $PizzaClient::SshotHud)
		return;
	else if(%type == 2 && $PizzaClient::SnipeSshotHud)
		return;
		
	if(%val)
	{
		canvas.setContent(panoramaGui);
		panoramaGui.beaconsVisible = false;
	}
	else
		canvas.setContent(playGui);
}

function handleDebriefingSshot()
{
	if(!$PizzaClient::SshotDebriefing || !$isPizzaServer)
		return;

	schedule(2000, 0, takeDebriefingScreenshot);
}

// source HalScore by Halide
function takeDebriefingScreenshot()
{
	if(!debriefGui.isAwake())
		return;

	canvas.cursorOff();
	canvas.repaint();

	for(%found = true; %found; $PizzaDebCount++)
	{
		%suffix = $PizzaDebCount @ ".";
		while(strLen(%suffix) < 5)
			%suffix = "0" @ %suffix;
		%fileName = "PizzaSshots/Debriefing" @ %suffix @ "png";
		%found = isFile(%fileName);
	}

	%dir = "base/" @ %fileName;

	screenShot(%dir);
	
	canvas.cursorOn();
}

function observeFirstFlag()
{
	commandToServer('ObserveFirstFlag');
}

function observeSecondFlag()
{
	commandToServer('ObserveSecondFlag');
}

package PizzaClientPkg
{

function sceneLightingComplete()
{
	if($isPizzaServer)
		commandToServer('ToggleBottomPrint', $PizzaClient::bottomPrint);
	
	parent::sceneLightingComplete();
}

function OptionsDlg::onWake(%this)
{
	if(!$PizzaHudBind)
	{
		$RemapName[$RemapCount] = "Pizza Client";
		$RemapCmd[$RemapCount] = "togglePizzaHud";
		$RemapCount++;

		$ObsRemapName[$ObsRemapCount] = "Obs First Flag";
		$ObsRemapCmd[$ObsRemapCount] = "observeFirstFlag";
		$ObsRemapCount++;

		$ObsRemapName[$ObsRemapCount] = "Obs Second Flag";
		$ObsRemapCmd[$ObsRemapCount] = "observeSecondFlag";
		$ObsRemapCount++;

		$PizzaHudBind = true;
	}

	parent::onWake(%this);
}

function lobbyVote()
{
   %id = LobbyVoteMenu.getSelectedId();
   %text = LobbyVoteMenu.getRowTextById(%id);

   switch$(LobbyVoteMenu.mode)
   {
      case "": // Default case...
         // Test for special cases:
         switch$($clVoteCmd[%id])
         {
            case "JoinGame":
               CommandToServer('clientJoinGame');
               schedule(100, 0, lobbyReturnToGame);
               return;
            
            case "ChooseTeam":
               commandToServer('ClientJoinTeam', -1, true);
               schedule(100, 0, lobbyReturnToGame);
               return;   

            case "VoteTournamentMode":
               LobbyVoteMenu.tourneyChoose = 1;
               fillLobbyMissionTypeMenu();
               return;
               
            case "VoteFFAMode":
            	if($isPizzaServer)
            	{
	            	LobbyVoteMenu.FFAChoose = 1;
	               fillLobbyMissionTypeMenu();
	               return;
	            }
	            else
	            {
	            	startNewVote($clVoteCmd[%id], $clVoteAction[%id]);
   					fillLobbyVoteMenu();
   					return;
   				}
               
            case "VoteMatchStart":
               startNewVote("VoteMatchStart");
               schedule(100, 0, lobbyReturnToGame);
               return;
            
            case "cancelMatchStart":
               startNewVote("cancelMatchStart");
               schedule(100, 0, lobbyReturnToGame);
               return;   

            case "MakeObserver":
               commandToServer('ClientMakeObserver');
               schedule(100, 0, lobbyReturnToGame);
               return;

            case "VoteChangeMission":
               fillLobbyMissionTypeMenu();
               return;

            case "VoteChangeTimeLimit":
               fillLobbyTimeLimitMenu();
               return;
            
            case "Addbot":
               commandToServer('addBot');
               return;
         }

      case "team":
         commandToServer('ClientJoinTeam', %id++);
         LobbyVoteMenu.reset();
         return;

      case "type":
         fillLobbyMissionMenu($clVoteCmd[%id], %text);
         return;

      case "mission":
         if(!LobbyVoteMenu.tourneyChoose && !LobbyVoteMenu.FFAChoose)
         {
            startNewVote("VoteChangeMission", 
                  %text,                        // Mission display name 
                  LobbyVoteMenu.typeName,       // Mission type display name 
                  $clVoteCmd[%id],              // Mission id                              
                  LobbyVoteMenu.missionType );  // Mission type id
         }
         else if(LobbyVoteMenu.tourneyChoose && !LobbyVoteMenu.FFAChoose)
         {
            startNewVote("VoteTournamentMode", 
                  %text,                        // Mission display name
                  LobbyVoteMenu.typeName,       // Mission type display name
                  $clVoteCmd[%id],              // Mission id
                  LobbyVoteMenu.missionType );  // Mission type id
            LobbyVoteMenu.tourneyChoose = 0;
         }
         else
         {
         	startNewVote("VoteFFA2Mode", 
                  %text,                        // Mission display name
                  LobbyVoteMenu.typeName,       // Mission type display name
                  $clVoteCmd[%id],              // Mission id
                  LobbyVoteMenu.missionType );  // Mission type id
            LobbyVoteMenu.FFAChoose = 0;
      	}
         LobbyVoteMenu.reset();
         return;

      case "timeLimit":
         startNewVote("VoteChangeTimeLimit", $clVoteCmd[%id]);
         LobbyVoteMenu.reset();
         return;
   }

   startNewVote($clVoteCmd[%id], $clVoteAction[%id]);
   fillLobbyVoteMenu();
}

function fillLobbyVoteMenu()
{
   LobbyVoteMenu.key++;
   LobbyVoteMenu.clear();
   LobbyVoteMenu.tourneyChoose = 0;
   LobbyVoteMenu.FFAChoose = 0;
   commandToServer('GetVoteMenu', LobbyVoteMenu.key);
}

function fillLobbyMissionMenu(%type, %typeName)
{
   LobbyVoteMenu.key++;
   LobbyVoteMenu.clear();
   LobbyVoteMenu.mode = "mission";
   LobbyVoteMenu.missionType = %type;
   LobbyVoteMenu.typeName = %typeName;
   
   if(LobbyVoteMenu.tourneyChoose || LobbyVoteMenu.FFAChoose)
   	commandToServer('GetMissionList', LobbyVoteMenu.key, %type, 1);
   else
   	commandToServer('GetMissionList', LobbyVoteMenu.key, %type, 0);
}

function LobbyVoteMenu::reset(%this)
{
   %this.mode = "";
   %this.tourneyChoose = 0;
   %this.FFAChoose = 0;
   LobbyCancelBtn.setVisible(false);
   fillLobbyVoteMenu();
}

function LobbyPlayerPopup::onSelect(%this, %id, %text)
{
   parent::onSelect(%this, %id, %text);

   switch$(%id)
   {
   	case 16:
   		commandToServer('Whois', %this.player.clientId);
   	case 17:
   		commandToServer('AddToBanList', %this.player.clientId);
   	case 18:
   		commandToServer('AddClanToBanList', %this.player.clientId);
   	case 19:
   		commandToServer('MakePlayerSuperAdmin', %this.player.clientId);
   }

   Canvas.popDialog(LobbyPlayerActionDlg);
}

function takeSShot(%file, %type)
{
	hidehuds(true, %type);
	
	GammaAdjust.extent = canvas.getExtent();
	GammaAdjust.opacity = $PizzaClient::sshotGamma;

	canvas.pushDialog(GammaAdjust);
	canvas.hideCursor();
	canvas.repaint();

	parent::screenShot(%file);

	canvas.showCursor();
	canvas.popDialog(GammaAdjust);
	
	hidehuds(false, %type);
}

function Disconnect()
{
   parent::Disconnect();
   $isPizzaServer = 0;
}

function quit()
{
	if(!$PizzaClientPrefsSaved)
	{
		export("$PizzaClient::*", "prefs/PizzaClientPrefs.cs", false);
		$PizzaClientPrefsSaved = true;
	}

	parent::quit();
}

};

activatePackage(PizzaClientPkg);

addMessageCallback('MsgMidAir', takeMAScreenShot);
addMessageCallback('MsgPlasmaMidAir', takeMAScreenShot);
addMessageCallback('MsgBlasterMidAir', takeMAScreenshot);
addMessageCallback('MsgSnipeShot', takeSnipeScreenShot);
addMessageCallback('MsgGameOver', handleDebriefingSshot);